import { select, 
         range,
         scaleOrdinal,
         scaleLinear,
         schemeTableau10,
         tsv,
         nest,
         pie,
         arc,
         selectAll,
         interpolate
        } 
from 'd3';


export const PieChartComponent = (selection,props) =>{

  

   const render = (data) =>{
     
      console.log(data)
     
      const pieF = pie().value( data => data.count).sort((a,b)=> {
         return a.region[0]>b.region[0]?1:-1;
      } )
      const piePath = pieF(data.values)
      
      console.log(piePath)
      
      piePath.map(d => d.category = data.key )
      drawChart(piePath)
    }
   
   const drawChart = (piePath) => {
     
       const arcf = arc();	
       const height = props.height
   		 const width = props.width
   		 const pieColorScale = scaleOrdinal(props.colorScale)
       
       const chartScale = scaleOrdinal().domain(['East','West','North','South','Central'])
       																	.range(schemeTableau10.slice(1,6))
       
   		 const innerRadius = props.innerRadius
   		 const outerRadius = props.outerRadius
   
   		 const group = selection
   							.attr("transform",
                      "translate(" + width / 2 + "," + height / 2 + ")");
  
       const groups = group.selectAll('g').data(piePath,d=> d.data.index)
       const groupEnter = groups.enter().append('g')
       const paths =   groupEnter.append('path')  
       const texts = groupEnter.append('text')

       paths.merge(groups.select('path')).attr('fill',d =>`hsl(${d.index* 160},${60}%,50%)`)
            .transition().delay(200)
            .attrTween('fill',d => t => {
               return chartScale(d.data.region);} )
            .attrTween('d',d => t => {
                          const p = arcf({
                          innerRadius: innerRadius,
                          outerRadius: outerRadius,
                          startAngle: t*d.startAngle,
                          endAngle: t*d.endAngle
                        })
                        return p;} )
     
        const textPos = (d,offsetA,offsetB) => arc().innerRadius(innerRadius+offsetA)
                      .outerRadius(outerRadius+offsetB)
                      .startAngle(d.startAngle)
                      .endAngle(d.endAngle)
        
        
         const offsetA = 120
         const offsetB = 90
     
         texts.merge(groups.select('text')).text(d=>d.data.region)
            .transition().delay(30)
              .attr('x',d=>{
                 return textPos(d,offsetA,offsetB).centroid()[0]
             })
              .attr('y',d=>{
                 return textPos(d,offsetA,offsetB).centroid()[1]
               })
              
     
         groups.exit().remove()

   	}
   
   
  
    
    
    return render;
}


