import { select, 
         range,
         scaleOrdinal,
         scaleLinear,
         schemeTableau10,
         tsv,
         nest,
         pie,
         arc,
         selectAll,
         interpolate
        } 
from 'd3';

export function OptionComponent(selection,component){
    
   const chartSelection = component.selection
   const Component = component.chart
   const colorScale = component.colorScale
   const height = component.height
   const width = component.width
   const def = component.default
   const innerRadius = component.innerRadius
   const outerRadius = component.outerRadius
   

   const drawOpt = (data,renderComponent,chartData) =>{
     
            
   					const labels = selection.selectAll('label').data(data).enter().append('label')
             labels.attr('name','fruit')
                        .attr('type','radio')
                        .text(d => d.key)

             labels.append('input')
                   .attr('type','radio')
                   .attr('name','fruit')
                   .attr('id',d=> d.key)
                   .on("change", data => {
                      chartData = data
               
                      renderComponent(chartData)
                                    })
             select(`input[id=${chartData.key}]`).attr('checked','')
             console.log(chartData)
             renderComponent(chartData)
   			}
 
   const render = (data) => {
      let componentData = data[def]
   
      const renderComponent = Component(chartSelection,{
                                          'height':height,
                                          'width':width,
                                          'colorScale':colorScale,
                                          'innerRadius':innerRadius,
                                          'outerRadius':outerRadius 
                                         })
      console.log(componentData)
      drawOpt(data,renderComponent,componentData)
   }
   
   return render
}